Bug 432185 - Assembler error assembling code generated by g++
Assembler error assembling code generated by g++
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: gcc (Show other bugs)
9
powerpc Linux
low Severity low
: ---
: ---
Assigned To: Jakub Jelinek
Fedora Extras Quality Assurance
: FutureFeature
Depends On:
Blocks: F-ExcludeArch-ppc FE-ExcludeArch-ppc64/F-ExcludeArch-ppc64 432033
  Show dependency treegraph
 
Reported: 2008-02-09 09:23 EST by Hans de Goede
Modified: 2009-07-14 11:25 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-07-14 11:25:59 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Hans de Goede 2008-02-09 09:23:22 EST
When doing scratch builds of crystalspace a new package under review, srpm here:
http://people.atrpms.net/~hdegoede/crystalspace-1.2-2.fc9.src.rpm

The compilation fails on ppc for both F-8 and F-9 scratchbuilds, see:
http://koji.fedoraproject.org/koji/taskinfo?taskID=407965
http://koji.fedoraproject.org/koji/taskinfo?taskID=403509

In both cases it fails with the following assembler messages, notice that the
c++ file in question does not contain inline asm:
{standard input}:1411397: Error: operand out of range (0x0000000000008000 is not
between 0xffffffffffff8000 and 0x0000000000007fff)
{standard input}:1411497: Error: operand out of range (0x0000000000008004 is not
between 0xffffffffffff8000 and 0x0000000000007fff)
{standard input}:1411510: Error: operand out of range (0x0000000000008008 is not
between 0xffffffffffff8000 and 0x0000000000007fff)
{standard input}:1411590: Error: operand out of range (0x000000000000800c is not
between 0xffffffffffff8000 and 0x0000000000007fff)
<many many more like these snipped>

Notice how:
1) the low and high limits of the reported range seem to be swapped
2) the reported out of range operand actually is not out of range
Comment 1 Jakub Jelinek 2008-02-09 15:08:16 EST
The low and high limits are not swapped, the range is signed, and the value is
of course out of range.  Can you please attach preprocessed source for the file
on which this is reported (and exact g++ command line options used to trigger it)?
Comment 2 Hans de Goede 2008-02-09 15:31:09 EST
(In reply to comment #1)
> The low and high limits are not swapped, the range is signed, and the value is
> of course out of range.
Ah, I see would help if the limits didn't get printed in hex then, then a human
would actually be able to recognize they are signed, but thats not the issue here.

  Can you please attach preprocessed source for the file
> on which this is reported (and exact g++ command line options used to trigger it)?

Erm, I can do that on x86_64 or i386, but not on ppc where this happens as I've
no access to ppc hardware. I'm not sure a preprocessed file from a different
platform is going to be very helpfull.

What might be important to know is that the file in question is a language
binding for python generated by swig.
Comment 3 Jakub Jelinek 2008-02-11 02:43:55 EST
If this is ppc64, then this is similar to #427700, though maybe different reason
why it now needs slightly more .got1 entries than it used to need with 4.1.
In any case the primary problem is that so big generated single CU is simply
excessively large for what ppc64 can handle.  So, you need to disable some
inlining to get it back under the limit.
Comment 4 Hans de Goede 2008-02-11 03:31:05 EST
(In reply to comment #3)
> If this is ppc64, then this is similar to #427700, though maybe different reason
> why it now needs slightly more .got1 entries than it used to need with 4.1.

This is not ppc64 but plain ppc, ppc64 is ExcludeArch for this package for
different reasons. Also notice that _exactly_ the same errors happen when
building for F-8, which AFAIK uses gcc-4.1 out of the box?

> In any case the primary problem is that so big generated single CU is simply
> excessively large for what ppc64 can handle.  So, you need to disable some
> inlining to get it back under the limit.

Okay, I'm willing to give this a try, can this be done by passing some options (
-ffoo-bar ) to gcc, or do I need todo something else, and in that case what do I
need todo?
Comment 5 Bug Zapper 2008-05-14 01:06:43 EDT
Changing version to '9' as part of upcoming Fedora 9 GA.
More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 6 Hans de Goede 2008-05-22 17:01:05 EDT
I've tried working around this by adding -fno-inline-small-functions at the end
of CFLAGS, but that didn't help, any other ideas how to work around this?
Comment 7 Bug Zapper 2009-06-09 19:31:56 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 8 Bug Zapper 2009-07-14 11:25:59 EDT
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.